////////////////////////////////////////////////////////////////////////////////////////////////////////
//Mit Creative01A kann man ein Bild zufällig oder aktiv erstellen, das farbige, in der 
//Mitte gerefften transparenten Tücher ähnelt.
//Mit linker Maustaste wird die Drehrichtung der Erzeugung umgekehrt
//Mit rechter Maustaste wird ein 180 Grad Sprung erzeugt
//Stoppen kann man den gesamten Prozess mit Shift+linke Maustaste
//Neustart mit Taste 'n'
//Drehrichtung-Umkehrungen und Sprünge werden auch vom Programm zufällig vorgenommen.
////////////////////////////////////////////////////////////////////////////////////////////////////////
float noiseVariable = 0.0;
float alpha = 0;
float delta = 0.005;//je größer desto stärker die Schwankungen in noise
int vz = 1;
int i=0;
float rMitte = 250;
float xRAlt,yRAlt;
float xRNeu,yRNeu;
float rNeu = 0;
float rAlt = rMitte;
float xM,yM;
boolean klein = false;
float r1,g1,b1;
float r2,g2,b2;
color[] farbAnker; 
color[] farben8192; // Anzahl Farben 8192, Ankerabstand: 64, Anzahl Anker 129
color farbe2 ;
color farbeMitAlpha;
float S1, S2 ; 
int abschnitte =129;
int ankerAbstand = 64;
boolean stopp = false;
boolean neustart = false;

void setup(){
  size(800,800);
  background(0); 
  xM = width/2;
  yM = height/2;
  farbAnker = new color[abschnitte];
  for(int i=0;i<abschnitte;i++){
     farbAnker[i] = color(0);
  }
  farbeMitAlpha = color(0);
  farben8192 = new color[8192];
  for(int i=0;i<8192;i++){
     farben8192[i] = color(0);
  }
  r1=random(256);
  g1=random(256);
  b1=random(256);
  farbAnker[0] = color(r1,g1,b1);
  for(int j=1; j<abschnitte; j++){
      farbAnker[j] = farbeBestimmen( farbAnker[j-1]);  
  }
  for(int i=0; i< abschnitte-1; i++){
    zwischenFarbenBestimmen(i*64,farbAnker[i],farbAnker[i+1]);
  }
  setFarbVerlauf(farben8192 );
  strokeWeight(3);
  xRAlt = xM + rAlt;
  yRAlt = yM;
   background(0); 
}

void draw() {
  if(neustart){
    background(0);
    neustart = false;
  }
  noiseVariable = noiseVariable + delta;
  rNeu =-100*sin(i/50.0)+ rMitte ;
  rNeu = rNeu + width/3*sin(i/50.0)*noise(noiseVariable);
  xRNeu = xM + rNeu*cos(alpha);
  yRNeu = yM + rNeu*sin(alpha);
  farbeMitAlpha = color(farben8192[i%8192],50);
  stroke(farbeMitAlpha);   
  if(i>0) line(xM,yM, xRNeu, yRNeu);
  xRAlt = xRNeu;
  yRAlt = yRNeu;
  rAlt = rNeu;
  if(random(0,1) < 0.004) vz = -vz;//links/rechts drehend
  if(random(0,1) < 0.001) alpha = alpha+PI;//180 Grad Sprung
  alpha+= vz*delta;
  i++;
  if(stopp){
    noLoop();
    println("fertig");
  }
}

color farbeBestimmen(color f){
  color farbe = color(0);//Initialisierung
  r2=random(256);
  g2=random(256);
  b2=random(256);
  S1 =red(f)+green(f)+blue(f); 
  S2 = r2+g2+b2; 
  while(abs(S1-S2)<255){
     r2=random(256);
     g2=random(256);
     b2=random(256);  
     S2 = r2+g2+b2;     
  }
  farbe = color(r2,g2,b2);
  return farbe;
}

void zwischenFarbenBestimmen(int k, color f1, color f2){
   int start = k;
   for(int i=start; i< ankerAbstand+start;i++){
      
      farben8192[i] = lerpColor(f1,f2,(float)(i-start)/64);
      //println(i,red(farben2048[i]),green(farben2048[i]),blue(farben2048[i]));
     // println(i,f1,f2,farben2048[i],(float)i/1024);
   }
}

void setFarbVerlauf(color[] farbTafel){
  this.farben8192 = farbTafel;
  for (int i = 0; i < 8192; i++) {     
      stroke(farben8192[i]); //println(i,red(farben2048[i]), green(farben2048[i]), blue(farben2048[i]));
      line(i, 0, i, height);
    }   
}

////////////////////////////////////////////////////////////////////
void mousePressed() { 
  if (mouseButton == LEFT && keyCode == SHIFT){  //Berechnung anhalten  
    stopp = true;
  }
  if (mouseButton == LEFT){  //Richtung drehen   
    vz = -vz;
  }
  if (mouseButton == RIGHT){  //180 Grad Sprung   
    alpha = alpha+PI;
  }
}
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
void keyPressed() {
   if (key == 's') {
     saveFrame("TransparenteTücher###.png");println("Bild gespeichert");
     redraw();
   }
   if (key == 'n') {
     neustart = true;
     println("Neustart");
     stopp = false;
     loop(); 
   }
   
}
  
  
